#ifndef ENVIRONMENT_H
#define ENVIRONMENT_H

#include <QtGui>

/* Run-time initialized data.
 */
class Environment
{
public:
	Environment(const QApplication&);

	// Answer the root directory for my install.  It seems like
	// QApplication::applicationDirPath() would cover this but
	// that seems to point to some resource fork.
	QString		getInstallPath() const;
	// Get the install sub-path, i.e. "(install)/shapes" when
	// called with SHAPES_DIR.
	QString		getInstallPath(const QString& sub) const;

private:
	QString		mInstallPath;
};

#endif // ENVIRONMENT_H
