#ifndef WIN_H
#define WIN_H

#include <QWidget>

#include "environment.h"
#include "ui/look.h"
#include "ui/navigation.h"

class QLabel;
class QLineEdit;
class QTextEdit;
class ActiveProject;
class ArcList;
class ColorSrcList;
class RenderView;
class StripView;

/* The top-level window for the application
 */
class Win : public QWidget
{
	Q_OBJECT

public:
	Win(const Environment&, const ArcList&, const ColorSrcList&,
		ActiveProject&, QWidget *parent = 0);

signals:

public slots:
	void					onSelectFx(const int fxId);

private:
	class NewFxUi;

	const Environment&		mEnv;
	const ArcList&			mArcs;
	const ColorSrcList&		mClrs;
	ActiveProject&			mPrj;
	Look					mLook;

	Navigation				mNavigation;

	RenderView*				mRenderView;
	StripView*				mStrip0;
	StripView*				mStrip1;
};

#endif // WIN_H
