#ifndef ARC_LIST_H
#define ARC_LIST_H

#include <QList>
#include <QString>
#include "engine/archead.h"

class ArcList;

/* ARC-LIST
 * A collection of arcs.
 ******************************************************************/
class ArcList
{
private:
	class Entry;

public:
	static void			addDefaults(ArcList&);

public:
	ArcList();
	~ArcList();

	bool				getArc(const int idx, ArcHead&, QString* name = NULL) const;

protected:
	bool				add(Entry*);

private:
	/* ENTRY
	 **************************************************************/
	class Entry {
	public:
		Entry();

		QString			mName;
		ArcHead			mArc;
	};
	QList<Entry*>		mE;
};

#endif // ARC_LIST_H
