#ifndef CONSTANT_H
#define CONSTANT_H

#include "engine/arc.h"

namespace arc {

/* CONSTANT
 * A constant value
 ******************************************************************/
class Constant : public Arc
{
public:
	Constant(const float v);
	Constant(const Constant&);

	virtual Constant*		copy() const;

	virtual void			getParams(param::List&, param::GetArgs&) const;
	virtual param::Parent*	findParent(param::UrlIterator&);
	virtual void			setParam(const param::UrlIterator&, param::SetArgs&);

	virtual void			work(WorkParams&, float* row);

#ifdef QT_DEBUG
	virtual void			printTree(const int tabs) const;
#endif

private:
	float					mV;
};

} // arc


#endif // CONSTANT_H
