#ifndef COLORSRC1_H
#define COLORSRC1_H

#include "engine/colorsrc.h"

/* COLOR-SRC-1
 * A ColorSrc on a single color (i.e. a constant).
 ******************************************************************/
class ColorSrc1 : public ColorSrc
{
public:
	ColorSrc1(const int r, const int g, const int b, const int a);

	virtual ColorSrc1*		copy() const;
	virtual void			get(const float v, color_f& output) const;
	virtual void			scaleAlpha(const float);

	virtual void			getParams(param::List&, param::GetArgs&) const;
	virtual void			setParam(const param::UrlIterator&, param::SetArgs&);

private:
	ColorSrc1(const ColorSrc1&);

	color_f					mClr;
};

#endif // COLORSRC1_H
