#ifndef COLORSRC2_H
#define COLORSRC2_H

#include "engine/colorsrc.h"

/* COLOR-SRC-2
 * A ColorSrc that interpolates between two colors.
 ******************************************************************/
class ColorSrc2 : public ColorSrc
{
public:
	ColorSrc2();

	virtual ColorSrc2*		copy() const;
	virtual void			get(const float v, color_f& output) const;
	virtual void			scaleAlpha(const float);

	virtual void			getParams(param::List&, param::GetArgs&) const;
	virtual void			setParam(const param::UrlIterator&, param::SetArgs&);

private:
	ColorSrc2(const ColorSrc2&);

	color_f					mClr0, mClr1;
};

#endif // COLORSRC2_H
