#include "mask.h"

#include <QDebug>

#include <stdlib.h>
#include <string.h>

/* MASK
 ******************************************************************/
Mask::Mask()
{
}

/* Misc
 ******************************************************************/

static const int		BUF_SIZE = 256;
static float			BUF_0[BUF_SIZE];
static float			BUF_1[BUF_SIZE];
static float			BUF_NEG_1[BUF_SIZE];

void init_mask()
{
	for (int k=0; k<BUF_SIZE; k++) {
		BUF_0[k] = 0;
		BUF_1[k] = 1;
		BUF_NEG_1[k] = -1;
	}
}

static void set_to(const float* src, float* dst, int dstSize)
{
	int				idx = 0;
	while (dstSize > 0) {
		const int	s = (dstSize > BUF_SIZE ? BUF_SIZE : dstSize);

		memcpy(dst+idx, src, s*sizeof(float));

		idx += s;
		dstSize -= s;
	}
}

void set_to_0(float* v, const int size)
{
	set_to(BUF_0, v, size);
}

void set_to_1(float* v, const int size)
{
	set_to(BUF_1, v, size);
}

void set_to_neg_1(float* v, const int size)
{
	set_to(BUF_NEG_1, v, size);
}
