#include "engineparam.h"

using namespace param;

/* PARAM::SET-ARGS
 ******************************************************************/
SetArgs::SetArgs()
	: mV(0)
	, mChanged(false)
{
}

SetArgs::SetArgs(const SetArgs& o)
{
	*this = o;
}

void SetArgs::operator=(const SetArgs& o)
{
	if (this != &o) {
		mV = o.mV;
		mStr = o.mStr;
		mArc.setTo(o.mArc);
		mClr = o.mClr;
		mChanged = o.mChanged;
	}
}

void SetArgs::clear()
{
	*this = SetArgs();
}

void SetArgs::readFrom(const Param& p)
{
	mV = p.mFV;
	mStr = p.mSV;
}

void SetArgs::writeTo(Param& p) const
{
	p.mFV = mV;
	p.mSV = mStr;
}
