#ifndef FXHEAD_H
#define FXHEAD_H

#include "engine/fxdefs.h"
#include "engine/parent.h"
#include "param/paramlist.h"
#include "param/paramurl.h"

class Fx;

/* FX-HEAD
 * Store a single FX object.
 ******************************************************************/
class FxHead
{
public:
    FxHead();
	~FxHead();

	Fx*					fx();
	const Fx*			fx() const;

	void				setFx(Fx*);

	void				getParams(param::List&, param::GetArgs&) const;

	param::Parent*		findParent(const param::Url&) const;

	// Exchange all data
	void				swap(FxHead&);

	void				forEach(fx::Visitor&, fx::VisitParams&);

private:
	Fx*					mFx;
};

/* inline
 ******************************************************************/
inline Fx* FxHead::fx()
{
	return mFx;
}

inline const Fx* FxHead::fx() const
{
	return mFx;
}

#endif // FXHEAD_H
