#ifndef FXUIDEFS_H
#define FXUIDEFS_H

#include <QSize>

class QPixmap;

namespace fxui {

/* FX-UI::BROWSER-MODEL.  The interface for classes that want
 * to make use of the browser control in the UI.  Add a browser
 * model to a Parent during the install process.
 ******************************************************************/
class BrowserModel {
public:
	virtual ~BrowserModel();

	virtual int				size() const = 0;

	virtual QSize			iconSize() const = 0;
	virtual const QPixmap*	at(const int idx) = 0;

	// Clients need to handle all the editing, since the framework
	// has no conception of what the data is.
	virtual void			setIndex(const int idx) = 0;

protected:
	BrowserModel();
};

} // namespace fxui

#endif // FXUIDEFS_H
