#ifndef SESSION_H
#define SESSION_H

#include "engine/fx.h"
class Worker;

/* SESSION
 * I hold the current processing info for the
 * rendering engine.  I own the worker object
 * while I'm holding it, so I will delete it if
 * necessary, but technically this should never
 * happen, it should always be returned back
 * to its creator FX.
 ********************************************/
class Session : public fx::Op
{
public:
	Session();
	virtual ~Session();

	// This is all the render client cares about.
	Worker*			mWorker;

	long			mSessionId;
	int				mWorkerId;

	void			start();
	void			beginFind();

	bool			isStart() const;

	virtual int		visit(Fx&, fx::VisitParams&);
};

#endif // SESSION_H
