#ifndef SURFACE_H
#define SURFACE_H

#include "math/primitives/quad.h"

/* SURFACE
 * A place to store normals.
 ********************************************/
class Surface
{
public:
    Surface();

	Quad			mQ;
	Point3			mNormal;
	// Each point has a normal that corresponds to whatever it's
	// connected to.
	Point3			mPtNormal[4];

	float			mL, mT, mR, mB;

	void			set(const Quad&);

	bool			containsCCW(const float x, const float y) const;

};

#endif // SURFACE_H
