#ifndef SURFACEACCUM_H
#define SURFACEACCUM_H

#include "engine/surfaceshader.h"

/* Shade surface geometry by accumulating the normals
 * for all overlapping vertices.
 */
class SurfaceAccum : public SurfaceShader
{
public:
	SurfaceAccum();
	virtual ~SurfaceAccum();

	virtual bool			init(const QuadList&);
	virtual const Surface*	find(const float x, const float y) const;
	virtual void			beginRow(const Surface&, const float y);
	virtual void			getAt(const float x, Params& out) const;

private:
	Surface*				mS;
	int						mSize;

	float					mX[2],	// 0 = left, 1 = right
							mZ[2];
	Point3					mN[2],
							mA, mB, mOut;

	void					fillAdjacentNormals();
	void					fill(const Surface& s, const int idx, const float y, const int dst);
};

#endif // SURFACEACCUM_H
