#ifndef SURFACENEIGHBOR_H
#define SURFACENEIGHBOR_H

#include "engine/surfaceshader.h"

/* Shade surface geometry by finding the quad neighbors.
 */
class SurfaceNeighbor : public SurfaceShader
{
public:
    SurfaceNeighbor();
	virtual ~SurfaceNeighbor();

	virtual bool			init(const QuadList&);
	virtual const Surface*	find(const float x, const float y) const;
	virtual void			beginRow(const Surface&, const float y);
	virtual void			getAt(const float x, Params& out) const;

private:
	Surface*				mS;
	int						mSize;

	float					mX[2],	// 0 = left, 1 = right
							mZ[2];
	Point3					mN[2],
							mA, mB, mOut;

	// During init
	int						mC[Quad::SIZE];

	void					fill(const Surface& s, const int idx, const float y, const int dst);

	void					fillAdjacentNormals();
	void					fillAccum(	Surface& src,
										const int srcA, const int srcB,
										const Surface& dst,
										const int dstA, const int dstB);
};

#endif // SURFACENEIGHBOR_H
