#ifndef BEVEL_H
#define BEVEL_H

#include "engine/fx.h"
#include "model/context.h"

#include "fx/light.h"

namespace fx {

/* BEVEL
 * Peform a beveling operation.  Requires
 * an input polygon.
 ******************************************************************/
class Bevel : public Fx
{
public:
	explicit Bevel(Context&);
	virtual ~Bevel();

	virtual Bevel*			copy() const;

	virtual QString			getLabel() const;

	virtual void			getParams(param::List&, param::GetArgs&) const;
	virtual param::Parent*	findParent(param::UrlIterator&);
	virtual void			setParam(const param::UrlIterator&, param::SetArgs&);

	virtual void			work(fx::WorkArgs&, fx::WorkOutput&);

private:
	Bevel(const Bevel&);

	float					mDepth;
	float					mLightAngle;
	float					mWire;

	// Temporary?
	Light					mLight;
};

} // fx

#endif // BEVEL_H
