#ifndef CHAIN_H
#define CHAIN_H

#include <QList>
#include "engine/fx.h"
#include "model/context.h"

namespace fx {

/* CHAIN
 * A chain does no compositing, it simply
 * runs FX in a sequence.
 ******************************************************************/
class Chain : public Fx
{
public:
	explicit Chain(Context&);
	virtual ~Chain();

	virtual Chain*			copy() const;

	virtual QString			getLabel() const;

	virtual void			getParams(param::List&, param::GetArgs&) const;
	virtual param::Parent*	findParent(param::UrlIterator&);
	virtual void			setParam(const param::UrlIterator&, param::SetArgs&);

	virtual int				forEach(Visitor&, VisitParams&);

	virtual void			work(fx::WorkArgs&, fx::WorkOutput&);

	void					append(Fx*);

private:
	Chain(const Chain&);
	QList<Fx*>				mFx;
};

} // fx

#endif // CHAIN_H
