#ifndef SHAPESRC_H
#define SHAPESRC_H

#include "engine/fx.h"
#include "model/context.h"

namespace fx {

/* SHAPE-SRC
 * Generate an input polygon.  Generally the
 * first FX in a layer.
 ******************************************************************/
class ShapeSrc : public Fx
{
public:
	explicit ShapeSrc(Context&);

	virtual ShapeSrc*		copy() const;

	virtual QString			getLabel() const;

	virtual void			getParams(param::List&, param::GetArgs&) const;
	virtual param::Parent*	findParent(param::UrlIterator&);
	virtual void			setParam(const param::UrlIterator&, param::SetArgs&);

	virtual void			work(fx::WorkArgs&, fx::WorkOutput&);

	virtual FxUi*			newUi(FxUi::Create&) const;

private:
	ShapeSrc(const ShapeSrc&);

	QString					mFilename;
	int						mNeedsCache;
};

} // fx

#endif // SHAPESRC_H
