#include "arcbrowser.h"

#include <QPixmap>
#include "model/context.h"
#include "arc/arc_list.h"
#include "arcui/arcrender.h"

/* ARC-BROWSER
 ******************************************************************/
ArcBrowser::ArcBrowser(Context& prj, const ArcList& al,
					   const Param& p, const QSize& iconSize)
	: mPrj(prj)
	, mArcs(al)
	, mIconSize(iconSize)
{
	mUrl = p.mUrl;
	ArcRender		ar;
	ArcHead			head;
	QString			name;
	for (int k=0; mArcs.getArc(k, head, &name); k++) {
		QPixmap*	pm = ar.onRender(head, mIconSize);
		if (pm != NULL) mE.append(pm);
	}
}

ArcBrowser::~ArcBrowser()
{
	while (!mE.isEmpty()) delete mE.takeFirst();
}

int ArcBrowser::size() const
{
	return mE.size();
}

QSize ArcBrowser::iconSize() const
{
	return mIconSize;
}

const QPixmap* ArcBrowser::at(const int idx)
{
	if (idx < 0 || idx >= mE.size()) return NULL;
	return mE[idx];
}

void ArcBrowser::setIndex(const int idx)
{
	ArcHead			head;
	if (mArcs.getArc(idx, head)) {
		mPrj.setParamArc(mUrl, head);
	}
}
