#ifndef ARCBROWSER_H
#define ARCBROWSER_H

#include "engine/fxuidefs.h"
#include "param/param.h"

class ArcList;
class Context;

/* ARC-BROWSER.  A model for selecting an item from the arc
 * list and setting it on a param.
 ******************************************************************/
class ArcBrowser : public fxui::BrowserModel
{
public:
	ArcBrowser(Context&, const ArcList&,
			   const Param& p, const QSize& iconSize);
	virtual ~ArcBrowser();

	virtual int				size() const;
	virtual QSize			iconSize() const;

	virtual const QPixmap*	at(const int idx);

	virtual void			setIndex(const int idx);

private:
	ArcBrowser(const ArcBrowser&);

	Context&			mPrj;
	const ArcList&		mArcs;
	param::Url			mUrl;
	const QSize			mIconSize;
	QList<QPixmap*>		mE;
};

#endif // ARCBROWSER_H
