#ifndef SHAPEBROWSER_H
#define SHAPEBROWSER_H

#include <QPixmap>

#include "engine/fxui.h"
#include "param/param.h"

namespace fxui {

/* SHAPE-BROWSER.  Display and
 * select all shapes in the system.
 *******************************/
class ShapeBrowser : public FxUi
{
public:
	ShapeBrowser(Create&, const param::Url& fileUrl);
	virtual ~ShapeBrowser();

	virtual void			setParent(Parent*, const Look&);
	virtual int				onProjectChanged();

private:
	typedef FxUi			inherited;

	const Environment&		mEnv;
	Context&				mPrj;
	const param::Url		mFileUrl;
	bool					mNeedsCache;

	/* FX-E.  One shape entry.
	 *******************************/
	class FxE : public Entry {
	public:
		FxE(Context&, const param::Url&, const QString& fn);

		bool				setImg(const int size, const Look&);

		virtual QSize		size() const;
		virtual void		onPaint(paint_args&);
		virtual void		mousePressEvent(const mouse_args& down);
		virtual void		mouseMoveEvent(const mouse_args& down);
		virtual void		mouseReleaseEvent(const mouse_args& down);

	private:
		Context&			mPrj;
		const param::Url&	mUrl;
		const QString		mFilename;
		QPixmap				mImg;
	};
	QList<FxE*>				mS;

	void					cache(const int entryH, const Look&);
	void					uncache();
};

} // fxui

#endif // SHAPEBROWSER_H
