#ifndef PLANEPLANE_H
#define PLANEPLANE_H

#include "math/primitives/plane.h"
#include "math/primitives/segment3.h"

namespace intersection {

class PlanePlane
{
public:
	static const int		INTERSECT = 0;		// Success!
	static const int		ERROR = -1;
	static const int		COINCIDENT = ERROR;
	static const int		DISJOINT = ERROR-1;

public:
	PlanePlane();

	// Segment L is actually an unbounded line, not a segment
	int						on(const Plane& p1, const Plane& p2, Segment3& L);

private:
	Point3					mU, mV,
							mIp;		// intersect point
};

} // intersection

#endif // PLANEPLANE_H
