#ifndef RAYQUAD_H
#define RAYQUAD_H

#include "math/intersection/raytri.h"
#include "math/primitives/quad.h"

namespace intersection {

/* Test to see where on the quad the ray intersects.
 * This is really just two tests for RayIntersectsTri,
 * so check that class for the return values.
 */
class RayQuad
{
public:
	RayQuad();

	// When the function is done, this will answer whether or
	// not the actual segment intersected (provided the test succeeded).
	bool					mSegmentIntersects;

	int on(const Segment3& ray, const Quad& q, Point3& out);

private:
	RayTri					mRIT;
};

} // intersection

#endif // RAYQUAD_H
