#ifndef MATHUTILS_H
#define MATHUTILS_H

#include "math/primitives/quad.h"

/* A quad point iterator.  This convenience class
 * is an unfortunate side effect of allowing quads
 * to degenerate into tris.  The iterator might have
 * 1 to 4 points.  Also, NOTE:  QUAD MUST EXIST FOR
 * THE LIFE OF THE ITERATOR.  I get pointers to the
 * points for performance, no copying.  Note that,
 * realistically, the difference would be much.
 */
class QuadIt
{
public:
	const Point3*		mPt[Quad::SIZE];
	int					mSize;

public:
	QuadIt();

	void				set(const Quad&);
};

#endif // MATHUTILS_H
