#include "polygon.h"

#include <stdlib.h>
#include <string.h>

#include "point3.h"

Polygon::Polygon()
	: mPt(0), mSize(0), mAlloc(0)
{
}

Polygon::~Polygon()
{
	realloc(mPt, 0);
}

qint32 Polygon::getSize() const
{
	return mSize;
}

Point3* Polygon::getPoints() const
{
	return mPt;
}

bool Polygon::set(const Polygon& o)
{
	if (!growTo(o.mSize)) return false;
	memcpy(mPt, o.mPt, sizeof(Point3)*o.mSize);
	mSize = o.mSize;
	return true;
}

bool Polygon::add(const double x, const double y, const double z)
{
	if (mSize >= mAlloc && !growTo(mSize + 10)) {
		return false;
	}
	mPt[mSize++].set(x, y, z);
	return true;
}

bool Polygon::growTo(const qint32 newAlloc)
{
	if (newAlloc <= mAlloc) return true;

	Point3*				newPt = (Point3*)realloc(mPt, newAlloc*sizeof(Point3));
	if (!newPt) return false;

	mPt = newPt;
	mAlloc = newAlloc;
	return true;
}
