#include "quad.h"

#include "math/geo.h"

Quad::Quad()
{
}

void Quad::set(const Quad& o)
{
	set(o.mPt[0], o.mPt[1], o.mPt[2], o.mPt[3]);
}

void Quad::set(	const Point3& a, const Point3& b,
				const Point3& c, const Point3& d)
{
	mPt[0] = a;
	mPt[1] = b;
	mPt[2] = c;
	mPt[3] = d;
}

bool Quad::isInwardTri() const
{
	return mPt[1].sameAs2(mPt[2]);
}

bool Quad::isOutwardTri() const
{
	return mPt[0].sameAs2(mPt[3]);
}

bool Quad::containsCCW(const float x, const float y) const
{
	if (geo::isInsideTri(mPt[0].x, mPt[0].y, mPt[1].x, mPt[1].y, mPt[2].x, mPt[2].y, x, y)) return true;
	return geo::isInsideTri(mPt[0].x, mPt[0].y, mPt[2].x, mPt[2].y, mPt[3].x, mPt[3].y, x, y);
}

QDebug& operator<<(QDebug& d, const Quad& q)
{
	d << q.mPt[0] << " " << q.mPt[1] << " " << q.mPt[2] << " " << q.mPt[3];
	return d;
}
