#ifndef QUAD_H
#define QUAD_H

#include <QtDebug>
#include "point3.h"

/* A quadrilateral.  Note that for my purposes, quads
 * can be degenerated into triangles.
 */
class Quad
{
public:
    Quad();

	static const int	SIZE = 4;

	Point3				mPt[SIZE];

	void				set(const Quad&);
	void				set(const Point3& a, const Point3& b,
							const Point3& c, const Point3& d);

	// I allow quads to collapse into triangles.  This is done
	// for the rendering engine, but it has lame repercussions
	// for all the geometry code.  There are two types of tris,
	// one where the inner points are identical (an inward tri),
	// ane one where the outer points are identical.
	bool				isInwardTri() const;
	bool				isOutwardTri() const;

	bool containsCCW(const float x, const float y) const;
};

QDebug& operator<<(QDebug&, const Quad&);

#endif // QUAD_H
