#ifndef CONTEXT_H
#define CONTEXT_H

#include "param/paramlist.h"
#include "param/paramurl.h"
#include "engine/colorsrchead.h"

class ArcHead;

/* CONTEXT
 * Provide environmental info related
 * to a project.
 ********************************************/
class Context
{
public:
	virtual int				nextFxUniqueId() = 0;

	// Copy the arc at the index in master list to the supplied arg.
	virtual bool			getArc(ArcHead&, const int idx) const = 0;

	// Get the default colorsrc
	virtual bool			getColorSrc(ColorSrcHead&, const ColorSrcMatch&) const = 0;

	// PROJECT behaviour
	// Answer true if I have the item identified by the url
	virtual bool			contains(const param::Url&) const = 0;

	virtual void			getParams(param::List&, param::GetArgs&) const = 0;
	virtual void			setParamF(const param::Url&, const float) = 0;
	virtual void			setParamStr(const param::Url&, const QString&) = 0;
	virtual void			setParamArc(const param::Url&, const ArcHead&) = 0;
	virtual void			setParamClr(const param::Url&, const ColorSrcHead&) = 0;

protected:
	Context()				{ }
	virtual ~Context()		{ }
};

#endif // CONTEXT_H
