#include "project.h"

#include "engine/fx.h"

/* PROJECT
 ******************************************************************/
Project::Project()
	: mTimeStamp(0)
{
}

Project::~Project()
{
}

void Project::swap(Project& o)
{
	int			ts = mTimeStamp; mTimeStamp = o.mTimeStamp; o.mTimeStamp = ts;
	mHead.swap(o.mHead);
}

bool Project::copyFrom(const Project& prj)
{
	mTimeStamp = prj.mTimeStamp;

	const Fx*		fx = prj.mHead.fx();
	if (fx == NULL) {
		mHead.setFx(NULL);
		return true;
	}
	mHead.setFx(fx->copy());
	return mHead.fx() != NULL;
}
