#ifndef PARAM_H
#define PARAM_H

#include <QString>
#include "param/paramurl.h"

/* PARAM
 * Info about a single user-editable parameter.
 ******************************************************************/
class Param
{
public:
	static const int			FLOAT_TYPE = 0;
	static const int			STRING_TYPE = 1;
	// All below are free for client-defined types.
	static const int			CLIENT_TYPE = 512;

public:
    Param();
	~Param();

	param::Url		mUrl;
	QString			mGroupName,
					mParamName;
	int				mType;
	// Value is one of the following
	float			mFV;
	QString			mSV;

	Param&			operator=(const Param&);
};

#endif // PARAM_H
