#ifndef BROWSERPOPUP_H
#define BROWSERPOPUP_H

#include "engine/fxui.h"

class QWidget;
class StripView;

/* BROWSER-POP-UP.  A fake widget for displaying a list of items
 * in a radial menu.
 ******************************************************************/
class BrowserPopUp : public FxUi::Entry
{
public:
	BrowserPopUp(QWidget&, StripView&, fxui::BrowserModel*);
	virtual ~BrowserPopUp();

	virtual int				flags() const;
	virtual QSize			size() const;
	virtual void			onPaint(FxUi::paint_args&);
	virtual void			mousePressEvent(const FxUi::mouse_args& down);
	virtual void			mouseMoveEvent(const FxUi::mouse_args& down);
	virtual void			mouseReleaseEvent(const FxUi::mouse_args& down);
	virtual int				onParamChanged(const Param&);

private:
	QWidget&				mParent;
	fxui::BrowserModel*		mModel;
	const QSize				mSize;
	bool					mExpanded;
	// When expanded, position will be somewhere between 0 and size-1.
	float					mPosition;

	QPoint					mDownPt;
	float					mDownV;

	bool					getIndex(int& outIdx, float& outOff) const;
};

#endif // BROWSERPOPUP_H
