#ifndef CHAINPLUG_H
#define CHAINPLUG_H

#include <QPixmap>

#include "engine/fx.h"
#include "engine/fxui.h"

class ActiveProject;
class Navigation;

/* CHAIN-PLUG.  Display the
 * project's current layer FX.
 ******************************************************************/
class ChainPlug : public FxUi
{
public:
	ChainPlug(ActiveProject&, Navigation&);
	virtual ~ChainPlug();

	virtual void				setParent(FxUi::Parent*, const Look&);
	virtual int					onProjectChanged();

private:
	typedef FxUi				inherited;
	ActiveProject&				mPrj;
	Navigation&					mNav;
	bool						mNeedsCache;

	class FxCacheOp;

	/* FX-E.  One FX entry.
	 **************************************************************/
	class FxE : public FxUi::Entry {
	public:
		FxE(Navigation&, const Fx&);

		virtual QSize			size() const;
		virtual void			onPaint(paint_args&);
		virtual void			mousePressEvent(const mouse_args& down);
		virtual void			mouseMoveEvent(const mouse_args& down);
		virtual void			mouseReleaseEvent(const mouse_args& down);

		void					cache(const int entryH, const Look&);

	private:
		Navigation&				mNav;
		const int				mFxId;
		const QString			mLabel;
		QPixmap					mImg;
	};
	QList<FxE*>					mE;

	void						cache(const int entryH, const Look&);
	void						uncache();
};

#endif // CHAINPLUG_H
