#ifndef RENDERIO_H
#define RENDERIO_H

#include <QSize>
#include "engine/engineparam.h"
#include "engine/fxdefs.h"
#include "model/project.h"

class Fx;

/* RENDER-IO
 * Classes that provide input and output for the render thread.
 ******************************************************************/
class RenderIn
{
public:
	static const int	ERR_TYPE = -1;
	static const int	FX_TYPE = 0;
	static const int	PARAM_TYPE = 1;

public:
	int					mType;
	Project				mPrj;
	QSize				mSize;
	Param				mParam;

public:
	RenderIn();
	~RenderIn();

	// NOTE:  I exchange incoming project info with my own,
	// leaving the incoming project empty.
	void				setProject(Project&, const QSize&);
	void				setParam(const Param&);

	void				clear();

private:
	RenderIn(const RenderIn&);
	void				operator=(const RenderIn&);
};

/* RENDER-OUT
 * Result of performing a render.
 ******************************************************************/
class RenderOut
{
public:
	explicit RenderOut(const QSize&);

	fx::WorkOutput		mOutput;

private:
	RenderOut(const RenderOut&);
	void				operator=(const RenderOut&);
};

#endif // RENDERIO_H
