#ifndef RENDERVIEW_H
#define RENDERVIEW_H

#include <QPen>
#include <QPixmap>
#include <QPointF>
#include <QSize>
#include <QWidget>

#include "engine/fx.h"
#include "renderthread.h"
class ActiveProject;

/* RENDER-VIEW
 * The widget that displays the main work area.
 ******************************************************************/
class RenderView : public QWidget
{
	Q_OBJECT
public:
	explicit RenderView(ActiveProject&, QWidget *parent = 0);

	QSize minimumSizeHint() const;
	QSize sizeHint() const;

signals:

public slots:
	void onProjectChanged(const int changedFlags);
	void onParamChanged(const Param&);

protected:
	 void paintEvent(QPaintEvent *event);

private:
	typedef QWidget	inherited;

	ActiveProject&			mPrj;
	RenderThread			mThread;

	// Set to true if I need to completely install the FX
	bool					mEmpty;

	// The bitmap buffer that gets painted
	QPixmap					mPixmap;
	QSize					mDataSize;

private slots:
	 void onRenderFinished();
};

#endif // RENDERVIEW_H
